Debian Bug report logs - #41091
Apt fails to install some packages

version graph

Package: apt; Maintainer for apt is APT Development Team <deity@lists.debian.org>; Source for apt is src:apt.

Reported by: Raphael Hertzog <rhertzog@hrnet.fr>

Date: Sat, 10 Jul 1999 21:48:01 UTC

Severity: wishlist

Found in version 0.3.11

Done: Jason Gunthorpe <jgg@ualberta.ca>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#41091; Package apt. Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <rhertzog@hrnet.fr>:
New bug report received and forwarded. Copy sent to APT Development Team <deity@lists.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <rhertzog@hrnet.fr>
To: submit@bugs.debian.org
Subject: Apt fails to install some packages
Date: Sat, 10 Jul 1999 23:30:19 +0200
Package: apt
Version: 0.3.11
Severity: normal

Background: i've build a fake status file with only the standard, required
and important packages (with some corrections, otherwise it would
have been broken). You can find it here :
http://pandora.debian.org/~hertzog/apt/status

And I'm trying to install all packages individually by using a
command line similar to this one :
apt-get -o Dir::State::status=$TDIR/$CODENAME-$ARCH/status \
          -o Dir::State=$TDIR/$CODENAME-$ARCH/apt-state/ \
          -o Dir::Cache=$TDIR/$CODENAME-$ARCH/apt-cache/ \
          -o Dir::Etc=$TDIR/$CODENAME-$ARCH/apt/ \
          -o APT::Architecture=$ARCH \
	-s install <package>
(forget about the variables names, they are not important, it's just
 for showing you which options i'm using)

And apt is able to install most of the packages from the distrib, only 79
of 3719 cannot be installed. And my bug report is precisely about those
failure.

The sources.list file looks like that :
deb file:/rack/ftp/debian potato main contrib non-free
deb file:/rack/ftp/debian-non-US potato/non-US main contrib non-free

In those failures there are several different cases :
- a package declares a Depends on a missing package, this is ok, apt-get
  should fail
- a package declares a Depends on a virtual package without giving
  advice (ie without using the "real | virtual" syntax). 
  Apt here simply fails like that :
=====
~/debian-cd/yacs@p200$ tools/apt-selection install nasm-mode 
Reading Package Lists... Done
Building Dependency Tree... Done
Some packages could not be installed. This may mean that you have
requested an impossible situation or if you are using the unstable
distribution that some required packages have not yet been created
or been moved out of Incoming.

Since you only requested a single operation it is extremely likely that
the package is simply not installable and a bug report against
that package should be filed.
The following information may help to resolve the situation:

Sorry, but the following packages have unmet dependencies:
  nasm-mode: Depends: xemacs20
E: Sorry, broken packages
=====
  It should be able to automatically install one of the xemacs20, the
  guess could be based on priority or whatever.

  Or at least it should fail with an explicative error (ie so that
  a program may detect what real problem there is) like :
  E: depends on a virtual package but doesn't suggest one to install

There are other cases were apt is failing with the same error but it
really should not. For example, if I decide to install dotfile-bash
it will fail because dotfile is not installed but if you add dotfile to
the command line then everything is ok :

~/debian-cd/yacs@p200$ tools/apt-selection install dotfile-bash
Reading Package Lists... Done
Building Dependency Tree... Done
Some packages could not be installed. This may mean that you have
requested an impossible situation or if you are using the unstable
distribution that some required packages have not yet been created
or been moved out of Incoming.

Since you only requested a single operation it is extremely likely that
the package is simply not installable and a bug report against
that package should be filed.
The following information may help to resolve the situation:

Sorry, but the following packages have unmet dependencies:
  dotfile-bash: Depends: dotfile (>= 1:2.3b1-0.1) but it is not installed
E: Sorry, broken packages

With dotfile on the command line :

~/debian-cd/yacs@p200$ tools/apt-selection install dotfile-bash dotfile
Reading Package Lists... Done
Building Dependency Tree... Done
The following extra packages will be installed:
  tkstep4.2 libtiff3g tkstep8.0 tcl7.6 tcl8.0 tk4.2 libjpeg62 tk8.0 xpm4g 
The following NEW packages will be installed:
  dotfile tkstep4.2 libtiff3g tkstep8.0 tcl7.6 tcl8.0 tk4.2 libjpeg62 tk8.0 xpm4g
  dotfile-bash 
0 packages upgraded, 11 newly installed, 0 to remove and 13 not upgraded.
Inst libjpeg62
Inst libtiff3g
Inst tcl8.0
[... skipping the other lines ...]
Conf tk8.0
Conf tk4.2
Conf dotfile
Conf dotfile-bash

I really don't know what could be causing this. BTW, apt-selection is a
wrapper that launch apt-get with a command line like I described at the
top.

And I have many similar problem with other packages : cmucl-clx and cmucl
for example or ifcico and ifmail. If you want more, simply ask, I've got 
the complete list here. :)

And a last request, is there a way to make apt-get automatically install
recommends (and/or suggests) ?

Cheers,
-- 
Hertzog Raphaël >> 0C4CABF1 >> http://prope.insa-lyon.fr/~rhertzog/


Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#41091; Package apt. Full text and rfc822 format available.

Acknowledgement sent to Josip Rodin <joy@cibalia.gkvk.hr>:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. Full text and rfc822 format available.

Message #10 received at 41091@bugs.debian.org (full text, mbox):

From: Josip Rodin <joy@cibalia.gkvk.hr>
To: Raphael Hertzog <rhertzog@hrnet.fr>, 41091@bugs.debian.org
Subject: Re: Bug#41091: Apt fails to install some packages
Date: Sun, 11 Jul 1999 00:49:30 +0200
On Sat, Jul 10, 1999 at 11:30:19PM +0200, Raphael Hertzog wrote:
> ~/debian-cd/yacs@p200$ tools/apt-selection install dotfile-bash dotfile
> Reading Package Lists... Done
> Building Dependency Tree... Done
> The following extra packages will be installed:
>   tkstep4.2 libtiff3g tkstep8.0 tcl7.6 tcl8.0 tk4.2 libjpeg62 tk8.0 xpm4g 
> The following NEW packages will be installed:
>   dotfile tkstep4.2 libtiff3g tkstep8.0 tcl7.6 tcl8.0 tk4.2 libjpeg62 tk8.0 xpm4g
>   dotfile-bash 
> 0 packages upgraded, 11 newly installed, 0 to remove and 13 not upgraded.
> Inst libjpeg62
> Inst libtiff3g
> Inst tcl8.0
> [... skipping the other lines ...]
> Conf tk8.0
> Conf tk4.2
> Conf dotfile
> Conf dotfile-bash

Weird. Dotfile depends on virtual packages wish and tclsh, but it
doesn't mind the version, because it runs under any one of them.
Is that really wrong?

-- 
enJoy -*/\*- spelled 'iosip', or simply 'joseph'


Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#41091; Package apt. Full text and rfc822 format available.

Acknowledgement sent to Jason Gunthorpe <jgg@ualberta.ca>:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. Full text and rfc822 format available.

Message #15 received at 41091@bugs.debian.org (full text, mbox):

From: Jason Gunthorpe <jgg@ualberta.ca>
To: Raphael Hertzog <rhertzog@hrnet.fr>, 41091@bugs.debian.org
Cc: APT Development Team <deity@lists.debian.org>
Subject: Re: Bug#41091: Apt fails to install some packages
Date: Sat, 10 Jul 1999 18:18:42 -0600 (MDT)

On Sat, 10 Jul 1999, Raphael Hertzog wrote:

> And apt is able to install most of the packages from the distrib, only 79
> of 3719 cannot be installed. And my bug report is precisely about those
> failure.

Well, APT has been designed to do alot of things in a good manner, some
cases do not go quite as you would like so that other cases behave
more sensibly. Likely you hare running into some of that.
 
> - a package declares a Depends on a virtual package without giving
>   advice (ie without using the "real | virtual" syntax). 
>   Apt here simply fails like that :

Packages that do this are somewhat in violation of policy, they are
supposed to declare a dependency on a real package so that tools like APT
and dselect have something they can choose. I remember looking into some of these before and
deciding there wasn't anything reasonable that could be done about them.

For instance nasm-mode has a depends line like this:

Depends: xemacs19 | xemacs20

What's a package manager to do? Basically APT gets upset when it finds or
groups and purely virtual packages that haven't been explicitly resolved,
it does not make random choices.

> There are other cases were apt is failing with the same error but it
> really should not. For example, if I decide to install dotfile-bash
> it will fail because dotfile is not installed but if you add dotfile to
> the command line then everything is ok :

This has to do with the wish packages if I remember properly.

> And I have many similar problem with other packages : cmucl-clx and cmucl
> for example or ifcico and ifmail. If you want more, simply ask, I've got 
> the complete list here. :)

Run your list with -o debug::pkgproblemresolver=true and see what the
causes of the failures are, there should be two categories
  - some types of OR groups
  - Virtual Packages w/o an OR to declare a default

The first I might be able to fix up some of them..

> And a last request, is there a way to make apt-get automatically install
> recommends (and/or suggests) ?

Nope, that would be complicated to get into a usable form.

Jason



Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#41091; Package apt. Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <rhertzog@hrnet.fr>:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. Full text and rfc822 format available.

Message #20 received at 41091@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <rhertzog@hrnet.fr>
To: Jason Gunthorpe <jgg@ualberta.ca>
Cc: 41091@bugs.debian.org, APT Development Team <deity@lists.debian.org>
Subject: Re: Bug#41091: Apt fails to install some packages
Date: Sun, 11 Jul 1999 15:15:22 +0200
Le Sat, Jul 10, 1999 at 06:18:42PM -0600, Jason Gunthorpe écrivait:
> Well, APT has been designed to do alot of things in a good manner, some
> cases do not go quite as you would like so that other cases behave
> more sensibly. Likely you hare running into some of that.

Yes, it's probable but as I need to run apt automatically on all packages,
when apt fails I need to know why so that I have a chance to try to
correct it.

> Packages that do this are somewhat in violation of policy, they are
> supposed to declare a dependency on a real package so that tools like APT
> and dselect have something they can choose. I remember looking into some
> of these before and deciding there wasn't anything reasonable that could
> be done about them.

As Josip mentionned, it's not yet part of the policy ... but maybe
should it ? If we agree on this, I may propose it to the policy 
group.

> For instance nasm-mode has a depends line like this:
> 
> Depends: xemacs19 | xemacs20
> 
> What's a package manager to do? Basically APT gets upset when it finds or
> groups and purely virtual packages that haven't been explicitly resolved,
> it does not make random choices.

Hey, maybe we could make a random choice ! An option -o 
random_if_not_explicitely could be useful to override those failure ...

Or something more intelligent that could sort the virtual packages on
which it does depend and choose the one that will install the less
packages, or the one with the highest priority, or the one whose
installed-size is the lowest and so on ...

Maybe it doesn't make much sense but it could be enabled by an option.

> This has to do with the wish packages if I remember properly.

Yes :
Starting
Starting 2
Package dotfile has broken dep on wish
  Considering tkstep8.0 0 as a solution to dotfile 1
  Holding Back dotfile rather than change wish
Package dotfile-bash has broken dep on dotfile
  Considering dotfile 1 as a solution to dotfile-bash 9999
    Reinst Failed because of wish
Done

Can you explain me the numbers that we see here ? The 1 and 0 and 9999 ?

But dotfile-bash does not have any virtual dependency, it's only dotfile
who has this virtual dependency. But the install of dotfile doesn't fail :

Starting
Starting 2
Package dotfile has broken dep on wish
  Considering tkstep8.0 0 as a solution to dotfile 9999
  Re-Instated libjpeg62
  Re-Instated libtiff3g
  Re-Instated tcl8.0
  Re-Instated xpm4g
  Re-Instated tkstep8.0
  Considering tkstep4.2 0 as a solution to dotfile 9999
  Re-Instated tcl7.6
  Re-Instated tkstep4.2
  Considering tk8.0 0 as a solution to dotfile 9999
  Re-Instated tk8.0
  Considering tk4.2 0 as a solution to dotfile 9999
  Re-Instated tk4.2
Done

> Run your list with -o debug::pkgproblemresolver=true and see what the
> causes of the failures are, there should be two categories
>   - some types of OR groups
>   - Virtual Packages w/o an OR to declare a default
> 
> The first I might be able to fix up some of them..

For cmucl-clx the problem is similar to the one of dotfile and
dotfile-bash :
apt-get install cmucl-clx tells :
Starting
Starting 2
Package cmucl has broken dep on lisp-core
  Considering cmucl-small 0 as a solution to cmucl 1
  Holding Back cmucl rather than change lisp-core
Package cmucl-clx has broken dep on cmucl
  Considering cmucl 1 as a solution to cmucl-clx 9999
    Reinst Failed because of lisp-core
Done

cmucl depends on lisp-core (without advice), but installing cmucl alone
works :
Starting
Starting 2
Package cmucl has broken dep on lisp-core
  Considering cmucl-small 0 as a solution to cmucl 9999
  Re-Instated cmucl-small
  Considering cmucl-safe 0 as a solution to cmucl 9999
  Re-Instated cmucl-safe
Done

The same for ifcico / ifmail, but the virtual package is
news-transport-sytem now ...

apt-get install ifcico :
Package ifmail has broken dep on news-transport-system
  Considering leafnode 0 as a solution to ifmail 1
  Holding Back ifmail rather than change news-transport-system
Package ifcico has broken dep on ifmail
  Considering ifmail 1 as a solution to ifcico 9998
    Reinst Failed because of news-transport-system

apt-get install ifmail :
Package ifmail has broken dep on news-transport-system
  Considering leafnode 0 as a solution to ifmail 9998
  Re-Instated leafnode
  Considering inn 0 as a solution to ifmail 9998
  Re-Instated inewsinn
  Re-Instated inn
  Considering cnews 0 as a solution to ifmail 9998
  Re-Instated cnews
Package inn has broken dep on news-transport-system
  Considering leafnode 9998 as a solution to inn 9998
  Holding Back inn rather than change news-transport-system
Package cnews has broken dep on inewsinn
  Considering inewsinn 0 as a solution to cnews 9998
Package cnews has broken dep on news-transport-system
  Considering leafnode 9998 as a solution to cnews 9998
  Holding Back cnews rather than change news-transport-system
Done

There's something wrong in all those cases, if apt-get is able to install
the package which does have the virtual dependency, it should also be able
to install the packages which depends on the package that have the virtual
dependency ...

Now let's see if I find other kind of failures ...

Yes there's "a broken or group" in tcpquota :
Starting
Starting 2
Note, a broken or group was found in tcpquota.
Package libdbd-mysql-perl has broken dep on libmysql6
Note, a broken or group was found in tcpquota.
Done
And the depends line look like this :
Depends: perl, libdbi-perl, libnet-perl, libdbd-mysql-perl | libdbd-msql-perl, m
ysql-base | msql

And you must know that all the mysql stuff is broken so that this could be
changed by depends on libdbd-msql-perl and msql. Apt seems to know that
since it does show you :
Sorry, but the following packages have unmet dependencies:
  tcpquota: Depends: libdbd-msql-perl but it is not installed
            Depends: msql but it is not installed

But it fails to install those two package even if they are installable :
$ apt-get install msql libdbd-msql-perl
Reading Package Lists... Done
Building Dependency Tree... Done
Starting
Starting 2
Done
The following extra packages will be installed:
  libdbi-perl libmsql2 
The following NEW packages will be installed:
  msql libdbi-perl libmsql2 libdbd-msql-perl

Strange isn't it ?

One more : fvwmconf :
Starting
Starting 2
Note, a broken or group was found in fvwmconf.
Done
[...]
Sorry, but the following packages have unmet dependencies:
  fvwmconf: Depends: fvwm (>= 2.2) but it is not installed

And the depends line :
Depends: perl-tk, fvwm2 (<< 2.2) | fvwm (>= 2.2)

fvwm2 does no more exist in potato but fvwm does ... and it fails to
install it even if it is perfectly installable :
$ apt-get install fvwm    
Reading Package Lists... Done
Building Dependency Tree... Done
Starting
Starting 2
Done
The following extra packages will be installed:
  xpm4g 
The following NEW packages will be installed:
  fvwm xpm4g

It did not yet find other kind of unnecessary failures.

Cheers,
-- 
Hertzog Raphaël >> 0C4CABF1 >> http://prope.insa-lyon.fr/~rhertzog/


Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#41091; Package apt. Full text and rfc822 format available.

Acknowledgement sent to Jason Gunthorpe <jgg@ualberta.ca>:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. Full text and rfc822 format available.

Message #25 received at 41091@bugs.debian.org (full text, mbox):

From: Jason Gunthorpe <jgg@ualberta.ca>
To: Raphael Hertzog <rhertzog@hrnet.fr>
Cc: 41091@bugs.debian.org, APT Development Team <deity@lists.debian.org>
Subject: Re: Bug#41091: Apt fails to install some packages
Date: Sun, 11 Jul 1999 16:12:42 -0600 (MDT)
On Sun, 11 Jul 1999, Raphael Hertzog wrote:

> Le Sat, Jul 10, 1999 at 06:18:42PM -0600, Jason Gunthorpe écrivait:
> > Well, APT has been designed to do alot of things in a good manner, some
> > cases do not go quite as you would like so that other cases behave
> > more sensibly. Likely you hare running into some of that.
> 
> Yes, it's probable but as I need to run apt automatically on all packages,
> when apt fails I need to know why so that I have a chance to try to
> correct it.

Why are you doing this? You know 'apt-cache unmet' will show you which
packages are not installable if this is what you are after. It even
considers recommends and suggests if you want.

> Or something more intelligent that could sort the virtual packages on
> which it does depend and choose the one that will install the less
> packages, or the one with the highest priority, or the one whose
> installed-size is the lowest and so on ...
> 
> Maybe it doesn't make much sense but it could be enabled by an option.
> 
> > This has to do with the wish packages if I remember properly.
> 
> Yes :
> Starting
> Starting 2
> Package dotfile has broken dep on wish
>   Considering tkstep8.0 0 as a solution to dotfile 1
>   Holding Back dotfile rather than change wish
> Package dotfile-bash has broken dep on dotfile
>   Considering dotfile 1 as a solution to dotfile-bash 9999
>     Reinst Failed because of wish
> Done
> 
> Can you explain me the numbers that we see here ? The 1 and 0 and 9999 ?

That is the assigned score given to a package, the higher the better.

> But dotfile-bash does not have any virtual dependency, it's only dotfile
> who has this virtual dependency. But the install of dotfile doesn't fail :

I forget why this is, but I spent a few hours looking at it and decided it
was the best thing to do. I'll look again..
 
I will take a look at dealing with the OR failures, they should be
solvable, right now it doesn't even try.

Jason



Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#41091; Package apt. Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <rhertzog@hrnet.fr>:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. Full text and rfc822 format available.

Message #30 received at 41091@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <rhertzog@hrnet.fr>
To: Jason Gunthorpe <jgg@ualberta.ca>
Cc: 41091@bugs.debian.org, APT Development Team <deity@lists.debian.org>
Subject: Re: Bug#41091: Apt fails to install some packages
Date: Mon, 12 Jul 1999 00:39:26 +0200
Le Sun, Jul 11, 1999 at 04:12:42PM -0600, Jason Gunthorpe écrivait:
> Why are you doing this? You know 'apt-cache unmet' will show you which
> packages are not installable if this is what you are after. It even
> considers recommends and suggests if you want.

Haha. :) I'm working on a script for creating the CDs, but each time I
include a package I need to include all dependencies that are needed,
that's why i'm running apt-get -s install and grep for the Inst lines to
know what packages are needed. Ideally I should add recommended packages
to this list ...

And yes I know, apt-cache, it's very useful too, thanks.

> > Can you explain me the numbers that we see here ? The 1 and 0 and 9999 ?
> 
> That is the assigned score given to a package, the higher the better.

The better for what ? The more likely to be used/installed ?

> I forget why this is, but I spent a few hours looking at it and decided it
> was the best thing to do. I'll look again..
>  
> I will take a look at dealing with the OR failures, they should be
> solvable, right now it doesn't even try.

Thanks !

Cheers,
-- 
Hertzog Raphaël >> 0C4CABF1 >> http://prope.insa-lyon.fr/~rhertzog/


Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#41091; Package apt. Full text and rfc822 format available.

Acknowledgement sent to Jason Gunthorpe <jgg@ualberta.ca>:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. Full text and rfc822 format available.

Message #35 received at 41091@bugs.debian.org (full text, mbox):

From: Jason Gunthorpe <jgg@ualberta.ca>
To: Raphael Hertzog <rhertzog@hrnet.fr>
Cc: 41091@bugs.debian.org, APT Development Team <deity@lists.debian.org>
Subject: Re: Bug#41091: Apt fails to install some packages
Date: Mon, 12 Jul 1999 21:01:45 -0600 (MDT)
On Mon, 12 Jul 1999, Raphael Hertzog wrote:

> Le Sun, Jul 11, 1999 at 04:12:42PM -0600, Jason Gunthorpe écrivait:
> > Why are you doing this? You know 'apt-cache unmet' will show you which
> > packages are not installable if this is what you are after. It even
> > considers recommends and suggests if you want.
> 
> Haha. :) I'm working on a script for creating the CDs, but each time I
> include a package I need to include all dependencies that are needed,
> that's why i'm running apt-get -s install and grep for the Inst lines to
> know what packages are needed. Ideally I should add recommended packages
> to this list ...

Well, in that case it would be more ideal to write a new apt-cache
function. You give it a list of packages and it prints out a dependecy
analyisis, you can then parse that to decide what to include. 

Even more sensible would be to just write your cd-fitting code using the
APT library, it has all the information directly available. If you outline
how you work it now I could probably write such a thing for you rather
quickly.

Otherwise if I make apt randomly install things you will end up with
several news-transport-agents (for example) when you really only need one.
 
Jason



Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#41091; Package apt. Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <rhertzog@hrnet.fr>:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. Full text and rfc822 format available.

Message #40 received at 41091@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <rhertzog@hrnet.fr>
To: Jason Gunthorpe <jgg@ualberta.ca>
Cc: 41091@bugs.debian.org, APT Development Team <deity@lists.debian.org>
Subject: Re: Bug#41091: Apt fails to install some packages
Date: Tue, 13 Jul 1999 18:38:04 +0200
Le Mon, Jul 12, 1999 at 09:01:45PM -0600, Jason Gunthorpe écrivait:
> Well, in that case it would be more ideal to write a new apt-cache
> function. You give it a list of packages and it prints out a dependecy
> analyisis, you can then parse that to decide what to include. 
> 
> Even more sensible would be to just write your cd-fitting code using the
> APT library, it has all the information directly available. If you outline
> how you work it now I could probably write such a thing for you rather
> quickly.

Yes, that would be great ! Using apt-get enables me to do 2 things :
- detect easily all the dependent packages needed in order to
  make the CD consistent
- reject those where there is a real problem (dependency on a missing
  package for example)

The limit of the actual method is that some packages fails to be added
because apt-get fails to install them without more information ...

It would be great if you could write a function that would output something
like that :

$ apt-cache dep-tree sympa nasm-mode
Package: sympa
 Depends: mailtools
  Depends: libtime-date-perl
 Depends: libdigest-md5-perl
 Depends: libmime-perl
  Depends: libmime-base64-perl
 Depends: libmsgcat-perl
 Suggests: libnet-ldap-perl
  Depends: libconvert-ber-perl
 Suggests: libdbi-perl
 Recommends: sympa-doc
  Suggests:
Package: nasm-mode
 Depends: xemacs19-nomule, xemacs19-mule, ..., xemacs20-mule-canna

You should not list here dependencies that are already satisfied by
packages listed as installed in the status file.

Each line should only list one package when possible (ie when apt-get
can select one between more in a OR group). When there is a
virtual dependency, you should list all the packages that provides
the virtual package in question. I'll be able to use this information to
check if I have already included one of the listed packages...

Each space added (at the beginning) means one level deeper in the tree 
of course. All packages listed on a single line are supposed to be "ORed"
in the dependency line. It would be cool if we could control (with an
option) whether or not we want to travel through the Suggests and
Recommends line ... I don't need to see the Conflicts tree but you may
use this information to possibly reject some packages from an ORed group
if it conflicts with one of the package listed on the command line ...

Concerning unresolvable dependencies, you should list them, my program
will detect that it does need an non-existent package and it will not be
included.

And thank you very much for your proposal, at the beginning I wanted to
write something like that myself but I don't know C++ and had much
problems understanding the apt sources ...

Cheers,
-- 
Hertzog Raphaël >> 0C4CABF1 >> http://prope.insa-lyon.fr/~rhertzog/


Severity set to `wishlist'. Request was from Jason Gunthorpe <jgg@ualberta.ca> to control@bugs.debian.org. Full text and rfc822 format available.

Message sent on to Raphael Hertzog <rhertzog@hrnet.fr>:
Bug#41091. Full text and rfc822 format available.

Message #45 received at 41091-submitter@bugs.debian.org (full text, mbox):

From: Jason Gunthorpe <jgg@ualberta.ca>
To: Deity Creation Team <deity@lists.debian.org>
Subject: Another APT CVS version
Date: Fri, 22 Oct 1999 23:30:37 -0600 (MDT)
This is probably the last one before a .14 release..

Test it, slink .debs are at
http://www.debian.org/~jgg/apt_0.3.13.1_i386.deb, note they work on potato
fine.

Raphael, I belive that this version should really address your concerns
about or groups..

Jason

apt (0.3.13.1) unstable; urgency=low

  * Fix Perl or group pre-depends thing Closes: #46091, #46096, #46233, #45901
  * Fix handling of dpkg's conversions from < -> <= Closes: #46094, #47088
  * Make unparsable priorities non-fatal Closes: #46266, #46267, #46293, #46298
  * Fix handling of '/' for the dist name. Closes: #43830, #45640, #45692
  * Fixed 'Method gave a blank filename' error from IMS queries onto CDs.
    Closes: #45034, #45695, #46537
  * Made OR group handling in the problem resolver more elaborate. Closes: #45646
  * Added APT::Clean-Installed option. Closes: #45973
  * Moves the free space check to after the calculated size is printed.
    Closes: #46639, #47498
  * mipsel arch Closes: #47614
  * Beautified URI printing to not include passwords Closes: #46857
  * Fixed little problem with --no-download Closes: #47557
  * Tweaked Dselect 'update' script to re-gen the avail file even in the
    event of a failure Closes: #47112
  * Retries for source archives too Closes: #47529
  * Unmounts CDROMs iff it mounted them Closes: #45299
  * Checks for the partial directories before doing downloads Closes: #47392
  * no_proxy environment variable (http only!) Closes: #43476
  * apt-cache showsrc Closes: #45799
  * De-Refs Single Pure virtual packages. Closes: #42437, #43555
  * Regexs for install. Closes: #35304, #38835
  * Dependency reports now show OR group relations
  * Re-Install feature. Cloes: #46961, #37393, #38919
  



Reply sent to Jason Gunthorpe <jgg@ualberta.ca>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Raphael Hertzog <rhertzog@hrnet.fr>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #50 received at 41091-done@bugs.debian.org (full text, mbox):

From: Jason Gunthorpe <jgg@ualberta.ca>
To: 41091-done@bugs.debian.org
Subject: Closed..
Date: Sat, 16 Sep 2000 21:01:19 -0600 (MDT)
This is a really really old discussion, I think as much as been resolved
as is possible.

Jason




Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Fri Apr 18 13:20:50 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.